//+------------------------------------------------------------------+
//|                                                      Vasilek.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define MAGICMA  123321123321

extern double Lots               = 0.1;
extern bool UseMoneyManagement = false;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 3;
extern string SL_MA_CAN_BE       = "       ";
extern string SL_MA_CAN_BE2      = "72,24,12,8   ";
extern double SL_MA              = 72;//    
extern string PARAMS             = "0   ";
extern double SL_Delta           = 300;//    
extern double TrailingStop       = 300;//
extern double NoLossLevel        = 300;//
extern double TakeProfit         = 0;//

double TP=0;
double SL=0;
double EMA72,EMA24,EMA12,EMA8,CustomEMA;

double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   if (UseMoneyManagement==false) lot=0.1;
   return(lot);
}


void CalculateLevels()
  {
SL=0;
  
   EMA72=iMA(NULL,0,72,0,MODE_EMA,PRICE_CLOSE,1);
   EMA24=iMA(NULL,0,24,0,MODE_EMA,PRICE_CLOSE,1);
   EMA12=iMA(NULL,0,12,0,MODE_EMA,PRICE_CLOSE,1);
   EMA8=iMA(NULL,0,8,0,MODE_EMA,PRICE_CLOSE,1);
   CustomEMA=iMA(NULL,0,SL_MA,0,MODE_EMA,PRICE_CLOSE,1);
   



 
   
  }
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {

   int    res;
   double s_level;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
   s_level=MarketInfo(Symbol(),14);
   
//---- sell conditions
   if (EMA24<EMA72 && EMA12<EMA72 && EMA8<EMA72)
     {
      if (TakeProfit>0) 
         {
         /*if ((Bid-TakeProfit*Point)<s_level) TP=Bid-s_level;
            else*/ TP=Bid-TakeProfit*Point;
         }
      if (SL_Delta>0) 
         {
         /*if (((CustomEMA+SL_Delta*Point)-Ask)<s_level) SL=Ask+s_level;
            else*/ SL=CustomEMA+SL_Delta*Point;
         }
  
      
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,SL,TP,"",MAGICMA,0,Red);
      return;
     }
//---- buy conditions
   if (EMA24>EMA72 && EMA12>EMA72 && EMA8>EMA72)  
     {
      if (TakeProfit>0) 
      {
      if ((Ask+TakeProfit*Point)<s_level) TP=Ask+s_level;
      else TP=Ask+TakeProfit*Point;
      }
      if (SL_Delta>0) 
      {
      if ((Bid-(CustomEMA-SL_Delta*Point))<s_level) SL=Bid-s_level;
      else SL=CustomEMA-SL_Delta*Point;
      }
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,SL,TP,"",MAGICMA,0,Blue);
      return;
     }
//----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {

//---- go trading only for first tiks of new bar
  if(Volume[0]>1) return;

//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         //if (Bid<SL)OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
               }
              if((TrailingStop<=0 || TrailingStop>NoLossLevel) && NoLossLevel>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*NoLossLevel)
                 {
                  if(OrderStopLoss()==0)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*NoLossLevel,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
               }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         //if (Ask>SL) OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
           if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           if((TrailingStop<=0 || TrailingStop>NoLossLevel) && NoLossLevel>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*NoLossLevel))
                 {
                  if(OrderStopLoss()==0)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*NoLossLevel,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
         break;
        }
     }
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) {CalculateLevels(); CheckForOpen();}
   else                                    {CalculateLevels(); CheckForClose();}
//----
  }
//+------------------------------------------------------------------+